﻿using Ant_Colony_Optimalization.Enum;
using Ant_Colony_Optimalization.Other;
using Ant_Colony_Optimalization.UserControls;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Ant_Colony_Optimalization
{
    public partial class FormMain : Form
    {
        public EProblemType ProblemType { get; set; }
        public UserControlGraph GraphPanelUserControl { get; set; }


        public FormMain()
        {
            InitializeComponent();
            this.ShowMainMenu();
        }

        public void ShowPanel(EProblemType problemType)
        {
            /*
            if (this.panelMain.Controls[0].GetType() != typeof(UserControlGraph))
            {
                this.GraphPanelUserControl = new UserControlGraph();
                this.panelMain.Controls.Clear();
                this.panelMain.Controls.Add(this.GraphPanelUserControl);
                this.GraphPanelUserControl.Dock = DockStyle.Fill;
                this.GraphPanelUserControl.Visible = true;
            }*/

            if (problemType == EProblemType.TSP)
            {

                this.GraphPanelUserControl = new UserControlGraph();
                this.panelMain.Controls.Clear();
                this.panelMain.Controls.Add(this.GraphPanelUserControl);
                this.GraphPanelUserControl.Dock = DockStyle.Fill;
                this.GraphPanelUserControl.Visible = true;

                this.panelLeft.Controls.Clear();
                this.panelLeft.Controls.Add(new UserControlTSPPanel());
                this.panelLeft.Controls[0].Dock = DockStyle.Fill;
                this.panelLeft.Controls[0].Visible = true;

            }

            if (problemType == EProblemType.ShortesPath)
            {

                this.GraphPanelUserControl = new UserControlGraph();
                this.panelMain.Controls.Clear();
                this.panelMain.Controls.Add(this.GraphPanelUserControl);
                this.GraphPanelUserControl.Dock = DockStyle.Fill;
                this.GraphPanelUserControl.Visible = true;

                this.panelLeft.Controls.Clear();
                this.panelLeft.Controls.Add(new UserControlPathPanel());
                this.panelLeft.Controls[0].Dock = DockStyle.Fill;
                this.panelLeft.Controls[0].Visible = true;

            }

        }

        public Type GetLeftPanelType()
        {
            return this.panelLeft.Controls[0].GetType();
        }

        public Control GetLeftPanel()
        {
            return this.panelLeft.Controls[0];
        }

        public void ShowMainMenu()
        {
            UserControlMainMenu userControlMain = new UserControlMainMenu();
            this.panelMain.Controls.Clear();
            userControlMain.Dock = DockStyle.Fill;
            this.panelMain.Controls.Add(userControlMain);
            userControlMain.Visible = true;
            this.panelLeft.Controls.Clear();
        }

        public void ShowResults(EProblemType problemType,CSettingsHolder runSettings)
        {
            if (problemType == EProblemType.TSP)
            {
                this.panelLeft.Controls.Clear();
                this.panelLeft.Controls.Add(new UserControlTSPResults(runSettings));
                this.panelLeft.Controls[0].Dock = DockStyle.Fill;
                this.panelLeft.Controls[0].Visible = true;
            }
            else
            {
                this.panelLeft.Controls.Clear();
                this.panelLeft.Controls.Add(new UserControlPathResult(runSettings));
                this.panelLeft.Controls[0].Dock = DockStyle.Fill;
                this.panelLeft.Controls[0].Visible = true;
            }
        }

        public void Run()
        {
            this.backgroundWorker1.RunWorkerAsync();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            try
            {
                for (int i = 0; i < 100; i++)
                {
                    this.backgroundWorker1.ReportProgress(i, null);
                    Thread.Sleep(1000);
                }
            }
            catch (Exception z)
            {
                MessageBox.Show(z.Message.ToString());
            }
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            try
            {
                this.Text = e.ProgressPercentage.ToString();
            }
            catch (Exception z)
            {
                MessageBox.Show(z.Message.ToString());
            }
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {

        }
    }
}
